// Gadget settings
// Gadget settings
var smallDockedWidth = 118;
var smallDockedHeight = 221;
var smallDockedFrameTop = -140;
var smallDockedFrameLeft = -493;

var bigDockedWidth = 165;
var bigDockedHeight = 271;
var bigDockedFrameTop = -93;
var bigDockedFrameLeft = -475;

var dockedWidth = 0;
var dockedHeight = 0;
var dockedFrameTop = 0;
var dockedFrameLeft = 0;

var undockedWidth = 630;
var undockedBaseHeight = 278;
var undockedFrameTop = -91;
var undockedFrameLeft = -58;

var subscriberFrameTop = 0;
var subscriberFrameLeft = -12;
var nonsubscriberFrameTop = -94;
var nonsubscriberFrameLeft = -19;

var subscriberTopSmallOffset = 91;
var subscriberLeftSmallOffset = 54;
var nonsubscriberTopSmallOffset = 0;
var nonsubscriberLeftSmallOffset = 0;

var topOffset = 0;
var leftOffset = 0;

var shareExtraHeight = 90;

var stopped = true;
var beenHere = false;

var interval;

var updateRequest;
var version = "1.6.1.0";
var osVersion;
var cpuType;


// Declare the dock and undock event handlers.
System.Gadget.onDock = CheckDockState;
System.Gadget.onUndock = CheckDockState;
System.Gadget.onSettingsClosed = SettingsClosed;

function init() {
  System.Gadget.settingsUI = "settings.html";
  System.Gadget.Flyout.file = "flyout.html";
  getOSVersion();
  cpuType = navigator.cpuClass;
  readSize();
  if( System.Gadget.Settings.read("subscriber") ) {
    undockedFrameTop = subscriberFrameTop;
    undockedFrameLeft = subscriberFrameLeft;
    topOffset = subscriberTopSmallOffset;
    leftOffset = subscriberLeftSmallOffset;
  }
  if( System.Gadget.Settings.read("startup") )
    setTimeout("clickStartStop()", 300);
  if( System.Gadget.Settings.read("update") )
    setTimeout("checkForUpdate()", 3000);
  startRefresh();
}

function getOSVersion() {
  if(navigator.appVersion.indexOf("Windows NT 6.1") > -1)
    osVersion = "seven";
  else
    osVersion = "vista";
}

// Check the gadget dock state; set the gadget style.
function CheckDockState()
{
    var oBody = document.body.style;
    var iframe = document.getElementById("radioFrame");
    var btn = document.getElementById("startstop").style;
    if (System.Gadget.docked)
    {
	    oBody.width = dockedWidth;
	    oBody.height = dockedHeight;
	    document.getElementById("bottom").style.top = dockedHeight - 5;
	    document.getElementById("bottomleft").style.top = dockedHeight - 5;
	    document.getElementById("bottomright").style.top = dockedHeight - 5;
	    iframe.style.width = dockedWidth - 10;
	    iframe.style.height = dockedHeight - 34;
	    if(!stopped) {
	      var innerFrame = iframe.contentWindow.document.getElementById("innerFrame");
        innerFrame.style.top = dockedFrameTop + topOffset;
        innerFrame.style.left = dockedFrameLeft + leftOffset;
      } else {
        if( System.Gadget.Settings.readString("firstRun") != "no" && !beenHere) {
          System.Gadget.Settings.write("update", 1);
          beenHere = true;
          if(hasFlash()) {
            if(osVersion == "vista")
              var directions = "drag this gadget out of the Sidebar";
            else
              var directions = "click the 'larger size' button on the right";
            iframe.contentWindow.document.write("<html><body bgcolor=\"#1C2D37\" style=\"font-family: 'Segoe UI', 'sans-serif';color: #336799;margin: 2px;font-size: small;\">To log in, " + directions + ".</body></html>");          
          } else {
						if(cpuType == "x64")
							iframe.contentWindow.document.write("<html><body bgcolor=\"#1C2D37\" style=\"font-family: 'Segoe UI', 'sans-serif';color: #336799;margin: 2px;font-size: small;\"><p>Since Flash is 32-bit, you'll need to do some tweaking on a 64-bit system.</p><p><a href='http://bgreco.net/gadgets/pandora/64.php?" + osVersion + "'>Click here</a> for directions.</p></body></html>");
						else
							iframe.contentWindow.document.write("<html><body bgcolor=\"#1C2D37\" style=\"font-family: 'Segoe UI', 'sans-serif';color: #336799;margin: 2px;font-size: small;\"><p>You need to install the Flash player for Internet Explorer.</p><p><a href='http://www.adobe.com/go/full_flashplayer_win_ie'>Click here</a> to download.</p></body></html>");          
          }
          document.getElementById('startstop').style.display = 'none';
        }
      }
	    btn.top = dockedHeight - 25;
	    btn.left = (dockedWidth - 34) / 2;
    }
    else
    {
      oBody.width = undockedWidth;
      var undockedHeight = undockedBaseHeight;
      if(System.Gadget.Settings.read("share"))
				undockedHeight += shareExtraHeight;
	    oBody.height = undockedHeight;
	    document.getElementById("bottom").style.top = undockedHeight - 5;
	    document.getElementById("bottomleft").style.top = undockedHeight - 5;
	    document.getElementById("bottomright").style.top = undockedHeight - 5;
	    iframe.style.width = undockedWidth - 10;
	    iframe.style.height = undockedHeight - 34;
	    if(!stopped) {
	      var innerFrame = iframe.contentWindow.document.getElementById("innerFrame");
        innerFrame.style.top = undockedFrameTop;
        innerFrame.style.left = undockedFrameLeft;
      } else {
        if( System.Gadget.Settings.readString("firstRun") != "no" && hasFlash() ) {
          document.getElementById('startstop').style.display = '';
          System.Gadget.Settings.writeString("firstRun", "no");
          clickStartStop();
        }
      }
	    btn.top = undockedHeight - 25;
	    btn.left = (undockedWidth - 34) / 2;
    }
}

function hoverStartStop() {
  CheckDockState();
  if( stopped )
    document.getElementById("startstop").style.background = "url(images/play-hover.png)";
  else
    document.getElementById("startstop").style.background = "url(images/stop-hover.png)";
}

function exitStartStop() {
  if( stopped )
    document.getElementById("startstop").style.background = "url(images/play.png)";
  else
    document.getElementById("startstop").style.background = "url(images/stop.png)";
}

function clickStartStop() {
  if( stopped ) {
    document.getElementById("startstop").style.background = "url(images/stop-hover.png)";
    document.getElementById("radioFrame").src = "frame.html";
    stopped = false;
  } else {
    document.getElementById("startstop").style.background = "url(images/play-hover.png)";
    document.getElementById("radioFrame").src = "stopped.html";
    stopped = true;
  }
  setTimeout("CheckDockState()", 100);
}

function setSize( size ) {
  if( size == "big" ) {
    dockedWidth = bigDockedWidth;
    dockedHeight = bigDockedHeight;
    dockedFrameTop = bigDockedFrameTop;
    dockedFrameLeft = bigDockedFrameLeft;
  } else {
    dockedWidth = smallDockedWidth;
    dockedHeight = smallDockedHeight;
    dockedFrameTop = smallDockedFrameTop;
    dockedFrameLeft = smallDockedFrameLeft;
  }
  setTimeout("CheckDockState()", 300);
}

function SettingsClosed(event)
{
  if (event.closeAction == event.Action.commit) {
    readSize();
  }
  startRefresh();
}

function readSize() {
  if( System.Gadget.Settings.read("big") )
    setSize( "big" );
  else
    setSize( "small" );
  
  if( System.Gadget.Settings.read("subscriber") ) {
    undockedFrameTop = subscriberFrameTop;
    undockedFrameLeft = subscriberFrameLeft;
    topOffset = subscriberTopSmallOffset;
    leftOffset = subscriberLeftSmallOffset;
    setTimeout("CheckDockState()", 300);
  } else {
    undockedFrameTop = nonsubscriberFrameTop;
    undockedFrameLeft = nonsubscriberFrameLeft;
    topOffset = nonsubscriberTopSmallOffset;
    leftOffset = nonsubscriberLeftSmallOffset;
    setTimeout("CheckDockState()", 300);
  }    
}

function startRefresh() {
  if( System.Gadget.Settings.read("refresh") ) {
    interval = setInterval(function() {
      document.getElementById("radioFrame").contentWindow.document.getElementById('innerFrame').contentWindow.location.reload();
    }, 1000 * 60 * 59);
  } else if( interval ) {
    clearInterval( interval );
  }
}

function checkForUpdate() {
  updateRequest = new XMLHttpRequest();
  updateRequest.onreadystatechange = processReqChange;
  updateRequest.open("GET", "http://www.bgreco.net/gadgets/pandora/update.php?ver=" + version, true);
  updateRequest.send(null);
}

function processReqChange() {
  if (updateRequest.readyState == 4 && updateRequest.status == 200) {
    if( updateRequest.responseText == "0" )
      System.Gadget.Flyout.show = true;
  }
}

function hasFlash() {
	try {
		var control = new ActiveXObject('ShockwaveFlash.ShockwaveFlash');
		return true;
	} catch (e) {
		return false;
	}
}